#include <WinUser32.mqh>
#include <stdlib.mqh>
//----
#define FILE_NAME "MQL_Quotes.ex4"
#define WRONG_FILE_EXT "  :    *.hst "
#define WRONG_FILE_EXT_HDR "  "
//----
// /    
//  == true,   
//  == false,     O=H=L=C
bool		SkipWeekEnd	    = true;
// ,       
//-   ,      .
bool     Save_HST       = true;
int      Periods        = 1;

string input_file_name = "";
string	ChartList = "";
//----
int hst_handle;
int err;
double digit;
int xxx,Volumes,Vol;
string query = "";
int length = 0;
string iTimeYear, iTimeMonth, iTimeDay, iTimeHour, iTimeMinute, iTimeSeconds, bar_time_str, _query = "";
int        ExtHandle = -1;
static int  ArrPeriod[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string list[] = { "GBPAUD", "GBPCAD", "NZDCAD", "NZDCHF" };
int myerr;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init(){

}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   for (int i = 0; i < ArraySize(list); i++){
      input_file_name = list[i]+Periods+".hst";
      ChartList = StringConcatenate(list[i],Periods);
      if (Save_HST) onestart();
//   
       if (Save_HST){
         _query      = StringConcatenate("\\hst\\M",Periods,"\\/");
         hst_handle  = FileOpen(_query+input_file_name, FILE_BIN | FILE_READ);
       } else {
         hst_handle = FileOpenHistory(input_file_name, FILE_BIN | FILE_READ);
       }
       err = GetLastError();
       //if(hst_handle < 0 || err > 0) return(error_out(err, "  "));

//  
      FileSeek(hst_handle, 68, SEEK_SET);
      err = GetLastError();
      if(err > 0) return(error_out(err, "     "));
      string hst_symbol = FileReadString(hst_handle, 12);
      int hst_period = FileReadInteger(hst_handle, LONG_VALUE);
      err = GetLastError();
      if(err > 0) return (error_out(err, "  *.hst "));
      FileSeek(hst_handle, 64, SEEK_CUR);
      err = GetLastError();
      if(err > 0) return(error_out(err, "      "));

//     
      while(!FileIsEnding(hst_handle)){
      err = GetLastError();
      if(err > 0) return(error_out(err, " EOF   "));
//     
       int bar_time        = FileReadInteger(hst_handle, LONG_VALUE);
       double bar_open     = FileReadDouble(hst_handle, DOUBLE_VALUE);
       double bar_low      = FileReadDouble(hst_handle, DOUBLE_VALUE);
       double bar_high     = FileReadDouble(hst_handle, DOUBLE_VALUE);
       double bar_close    = FileReadDouble(hst_handle, DOUBLE_VALUE);
       double bar_volume   = FileReadDouble(hst_handle, DOUBLE_VALUE);
       err = GetLastError();
       if(err == 4099) break; //   ,  
       if(err > 0) return(error_out(err,"   "));
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+   
   } // while
   FileClose(hst_handle);
   err = GetLastError();
   if(err > 0) return(error_out(err, " "));   
   }   
   err = GetLastError();
   if(err > 0) return(error_out(err, " EOF   "));
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int error_out(int err, string where){
    if(err == 0) return;
    string message = StringConcatenate(" ", err, ":\"", 
                                       ErrorDescription(err), "\"\n",
                                       "    \"", 
                                       where,"\"");
    //string caption = StringConcatenate("   : \"",FILE_NAME, "\"!");
    return(err);
  }

int onestart(){
	  int		_GetLastError = 0, cnt_copy = 0, cnt_add = 0, temp[13];
	  int		Charts = 0, pos = 0, curchar = 0, len = StringLen(ChartList);
	  string	cur_symbol = "", cur_period = "", file_name = "";
	  string	_Symbol[100]; int _Period[100], _PeriodSec[], _Bars[];
	  int		HistoryHandle[], hwnd[], last_fpos[], pre_time[], now_time[];
	  double	now_close[], now_open[], now_low[], now_high[], now_volume[];
	  double	pre_close[], pre_open[], pre_low[], pre_high[], pre_volume[];
	  datetime BeginDate,EndDate;
//----   ,   
	  while(pos <= len){
		     curchar = StringGetChar( ChartList, pos);
		     if(curchar > 47 && curchar < 58)
		         cur_period = cur_period + CharToStr( curchar ); 
		     else {
			        if(curchar == ',' || pos == len){ 
				           MarketInfo(cur_symbol, MODE_BID);
				           if(GetLastError() == 4106){
					              Print("  ", cur_symbol, "!!!");
					              return(-1);				
				             }
				           
				           if(iClose(cur_symbol, StrToInteger( cur_period ), 0) <= 0){
					              Print( "  ", cur_period, "!!!" );
					              return(-1);				
				             }
				           _Symbol[Charts] = cur_symbol; _Period[Charts] = StrToInteger(cur_period);
				           cur_symbol = ""; cur_period = "";
				           Charts ++;
			          } else cur_symbol = cur_symbol + CharToStr(curchar); 
		       }
		     pos++;
	    }
	  Print("< - - -  ", Charts, "  . - - - >");
	  ArrayResize( _Symbol,	      Charts); 
	  ArrayResize( _Period,	      Charts);
	  ArrayResize( HistoryHandle,	Charts); 
	  ArrayResize( hwnd,	         Charts);
	  ArrayResize( last_fpos,	   Charts); 
	  ArrayResize( pre_time,	   Charts);
	  ArrayResize( now_time,	   Charts); 
	  ArrayResize( now_close,	   Charts);
	  ArrayResize( now_open,	   Charts); 
	  ArrayResize( now_low,	      Charts);
	  ArrayResize( now_high,	   Charts); 
	  ArrayResize( now_volume,	   Charts);
	  ArrayResize( pre_close,	   Charts); 
	  ArrayResize( pre_open,	   Charts);
	  ArrayResize( pre_low,	      Charts); 
	  ArrayResize( pre_high,	   Charts);
	  ArrayResize( pre_volume,	   Charts); 
	  ArrayResize( _PeriodSec,	   Charts);
	  ArrayResize( _Bars,	      Charts);
	  for(int curChart = 0; curChart < Charts; curChart++){
		     _PeriodSec[curChart] = _Period[curChart]*60;
		     //----  ,     
		     file_name = StringConcatenate(_Symbol[curChart], _Period[curChart], ".hst");
		     _query = StringConcatenate("\\hst\\M",Periods,"\\/");
		     HistoryHandle[curChart] = FileOpen(_query+file_name, FILE_BIN | FILE_WRITE);
		     if(HistoryHandle[curChart] < 0){
			        _GetLastError = GetLastError();
			        Print("FileOpenHistory( \"", file_name, "\", FILE_BIN | FILE_WRITE )"," - Error #", _GetLastError);
			        continue;
		       }	
		     //----   
		     FileWriteInteger(HistoryHandle[curChart], 400, LONG_VALUE);
		     FileWriteString (HistoryHandle[curChart], "Copyright  2009, MQLab  Developer", 64);
		     FileWriteString (HistoryHandle[curChart], StringConcatenate("", _Symbol[curChart]), 12);
		     FileWriteInteger(HistoryHandle[curChart], _Period[curChart], LONG_VALUE);
		     FileWriteInteger(HistoryHandle[curChart], MarketInfo(_Symbol[curChart], MODE_DIGITS), LONG_VALUE);
		     FileWriteInteger(HistoryHandle[curChart], 0, LONG_VALUE);       //timesign
		     FileWriteInteger(HistoryHandle[curChart], 0, LONG_VALUE);       //last_sync
		     FileWriteArray	(HistoryHandle[curChart], temp, 0, 13);
		     //+------------------------------------------------------------------+
		     //|                                               |
		     //+------------------------------------------------------------------+
		     _Bars[curChart] = iBars(_Symbol[curChart], _Period[curChart]);
		     pre_time[curChart] = iTime(_Symbol[curChart], _Period[curChart], _Bars[curChart] - 1);
		     for(int i = _Bars[curChart] - 1; i >= 1; i--){
			        //----   

			        now_open[curChart]   = iOpen(_Symbol[curChart],   _Period[curChart], i);
			        now_high[curChart]   = iHigh(_Symbol[curChart],   _Period[curChart], i);
			        now_low[curChart]    = iLow(_Symbol[curChart],    _Period[curChart], i);
			        now_close[curChart]  = iClose(_Symbol[curChart],  _Period[curChart], i);
			        now_volume[curChart] = iVolume(_Symbol[curChart], _Period[curChart], i);
			        now_time[curChart]   = iTime(_Symbol[curChart],   _Period[curChart], i) / _PeriodSec[curChart];
			        now_time [curChart]  *= _PeriodSec[curChart];

				           if(SkipWeekEnd){
					              if(TimeDayOfWeek(now_time[curChart]) <= 0 || TimeDayOfWeek(now_time[curChart]) > 5) continue; 
				             }


               if (_Symbol[curChart] == "GBPAUD"){
                 BeginDate      = D'2008.12.31 23:59';
                 EndDate        = D'2008.01.08 10:04';
               }
               
               if (_Symbol[curChart] == "GBPCAD"){
                 BeginDate      = D'2008.12.31 23:59';
                 EndDate        = D'2009.01.08 08:45';
               }

               if (_Symbol[curChart] == "NZDCAD"){
                 BeginDate      = D'2008.12.31 23:58';
                 EndDate        = D'2009.01.08 05:43';
               }
               
               if (_Symbol[curChart] == "NZDCHF"){
                 BeginDate      = D'2008.12.31 23:59';
                 EndDate        = D'2009.01.08 06:04';
               }
               
                                                                           
			        if (now_time [curChart] >= BeginDate && now_time [curChart] < EndDate){
			        FileWriteInteger(HistoryHandle[curChart], now_time[curChart],  LONG_VALUE);
			        FileWriteDouble(HistoryHandle[curChart], now_open[curChart],	  DOUBLE_VALUE);
			        FileWriteDouble(HistoryHandle[curChart], now_low[curChart],	  DOUBLE_VALUE);
			        FileWriteDouble(HistoryHandle[curChart], now_high[curChart],	  DOUBLE_VALUE);
			        FileWriteDouble(HistoryHandle[curChart], now_close[curChart],  DOUBLE_VALUE);
			        FileWriteDouble(HistoryHandle[curChart], now_volume[curChart], DOUBLE_VALUE);
			        FileFlush(HistoryHandle[curChart]);
			        cnt_copy ++;
			        //----        
			        pre_close[curChart] = now_close[curChart];
			        pre_time[curChart]	 = now_time[curChart] / _PeriodSec[curChart];
			        pre_time[curChart]	 *= _PeriodSec[curChart];
 		         }
            }//   
		     last_fpos[curChart] = FileTell(HistoryHandle[curChart]);
	      //----  
	      FileClose(HistoryHandle[curChart]);
	      Print("< - - - ", _Symbol[curChart], _Period[curChart], ":  ", cnt_copy, "  - - - >");
	    }
	  return(0);
  }